diff --git a/policies/applications/zypperPackageManagerSettings/1.0/zypperPackageManagerSettings.st b/policies/applications/zypperPackageManagerSettings/1.0/zypperPackageManagerSettings.st
index 54a2502..731495d 100644
--- a/policies/applications/zypperPackageManagerSettings/1.0/zypperPackageManagerSettings.st
+++ b/policies/applications/zypperPackageManagerSettings/1.0/zypperPackageManagerSettings.st
@@ -32,6 +32,8 @@ bundle agent check_zypper_settings {
 }&
 		&ZYPPER_ENABLED:{zypper_enabled |"zypper_enabled[&i&]" string => "&zypper_enabled&";
 }&
+i		&TRACKINGKEY:{policyInstanceId |"zypper_uuid[&i&]" string => "&policyInstanceId&";
+}&
 
                 # List of all the files to permit on the vhost directory
                 "zypper_files" slist => { &ZYPPER_NAME: { "rudder-&it&.repo" };separator=", "&};
@@ -90,48 +92,48 @@ bundle agent check_zypper_settings {
 		# ZYPPER settings edition
 
 		zypper_conf_kept::
-			"@@zypperPackageManagerSettings@@result_success@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Zypper settings were all already correct";
+			"@@zypperPackageManagerSettings@@result_success@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Zypper settings were all already correct";
 
 		zypper_conf_validated::
-			"@@zypperPackageManagerSettings@@result_repaired@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Some Zypper settings were reset";
+			"@@zypperPackageManagerSettings@@result_repaired@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Some Zypper settings were reset";
 
 		zypper_conf_failed::
-			"@@zypperPackageManagerSettings@@result_error@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Zypper repositories could not be edited";
+			"@@zypperPackageManagerSettings@@result_error@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Zypper repositories could not be edited";
 
 		# Zypper repositories desactivation
 
                 zypper_disablerepositories.!repos_disabled_ok.!repos_disabled_fail::
-                        "@@zypperPackageManagerSettings@@result_success@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Every repository other than the defined ones were already disabled";
+                        "@@zypperPackageManagerSettings@@result_success@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Every repository other than the defined ones were already disabled";
 
                 zypper_disablerepositories.repos_disabled_ok::
-                        "@@zypperPackageManagerSettings@@result_repaired@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Every repository other than the defined ones were disabled";
+                        "@@zypperPackageManagerSettings@@result_repaired@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Every repository other than the defined ones were disabled";
 
                 zypper_disablerepositories.repos_disabled_fail::
-                        "@@zypperPackageManagerSettings@@result_error@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Could not disable the other repositories!";
+                        "@@zypperPackageManagerSettings@@result_error@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#Could not disable the other repositories!";
 
                 !zypper_disablerepositories::
-                        "@@zypperPackageManagerSettings@@result_success@@&TRACKINGKEY&@@General settings@@None@@$(g.execRun)##$(g.uuid)@#The repository desactivation has not been requested. Skipping...";
+                        "@@zypperPackageManagerSettings@@result_success@@${zypper_uuid[${zypper_index}]}@@General settings@@None@@$(g.execRun)##$(g.uuid)@#The repository desactivation has not been requested. Skipping...";
 
 		# Ignore non-SuSE OSes
 
 		!SuSE::
-			"@@zypperPackageManagerSettings@@result_error@@&TRACKINGKEY&@@zypperPackageManagerSettings@@None@@$(g.execRun)##$(g.uuid)@#ZYPPER cannot be configured on non SuSE OSes";
+			"@@zypperPackageManagerSettings@@result_error@@${zypper_uuid[${zypper_index}]}@@zypperPackageManagerSettings@@None@@$(g.execRun)##$(g.uuid)@#ZYPPER cannot be configured on non SuSE OSes";
 
 		!zypper_repositories_edit::
 
-			"@@zypperPackageManagerSettings@@result_success@@&TRACKINGKEY&@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The source $(zypper_name[$(zypper_index)]) will NOT be added as the repository addition parameter is off in the Policy Instance. Skipping...";
+			"@@zypperPackageManagerSettings@@result_success@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The source $(zypper_name[$(zypper_index)]) will NOT be added as the repository addition parameter is off in the Policy Instance. Skipping...";
 
 		SuSE::
 
                 # Repositories
 
-                        "@@zypperPackageManagerSettings@@result_success@@&TRACKINGKEY&@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The Zypper source $(zypper_name[$(zypper_index)]) was already here. Skipping..."
+                        "@@zypperPackageManagerSettings@@result_success@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The Zypper source $(zypper_name[$(zypper_index)]) was already here. Skipping..."
                                 ifvarclass => "zypper_$(zypper_index)_kept.!zypper_$(zypper_index)_validated";
 
-                        "@@zypperPackageManagerSettings@@result_repaired@@&TRACKINGKEY&@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The Zypper source $(zypper_name[$(zypper_index)]) has been successfully added"
+                        "@@zypperPackageManagerSettings@@result_repaired@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The Zypper source $(zypper_name[$(zypper_index)]) has been successfully added"
                                 ifvarclass => "zypper_$(zypper_index)_validated";
 
-                        "@@zypperPackageManagerSettings@@result_error@@&TRACKINGKEY&@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The Zypper source $(zypper_name[$(zypper_index)]) was NOT added!"
+                        "@@zypperPackageManagerSettings@@result_error@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_name[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The Zypper source $(zypper_name[$(zypper_index)]) was NOT added!"
                                 ifvarclass => "zypper_$(zypper_index)_error";
 
 
@@ -197,13 +199,13 @@ insert_lines:
 reports:
 
 	# Repositories
-	"@@zypperPackageManagerSettings@@result_success@@&TRACKINGKEY&@@Repository@@$(zypper_url[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The ZYPPER source $(zypper_name[$(zypper_index)]) was already here. Skipping..."
+	"@@zypperPackageManagerSettings@@result_success@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_url[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The ZYPPER source $(zypper_name[$(zypper_index)]) was already here. Skipping..."
 		ifvarclass => "source_$(zypper_index)_kept.!source_$(zypper_index)_ok";
 
-	"@@zypperPackageManagerSettings@@result_repaired@@&TRACKINGKEY&@@Repository@@$(zypper_url[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The ZYPPER source $(zypper_name[$(zypper_index)]) has been successfully added"
+	"@@zypperPackageManagerSettings@@result_repaired@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_url[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The ZYPPER source $(zypper_name[$(zypper_index)]) has been successfully added"
 		ifvarclass => "source_$(zypper_index)_ok";
 
-	"@@zypperPackageManagerSettings@@result_error@@&TRACKINGKEY&@@Repository@@$(zypper_url[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The ZYPPER source $(zypper_name[$(zypper_index)]) was NOT added!"
+	"@@zypperPackageManagerSettings@@result_error@@${zypper_uuid[${zypper_index}]}@@Repository@@$(zypper_url[$(zypper_index)])@@$(g.execRun)##$(g.uuid)@#The ZYPPER source $(zypper_name[$(zypper_index)]) was NOT added!"
 		ifvarclass => "source_$(zypper_index)_failed";
 
 }